package frontend

import (
	"html/template"
	"net/http"

	b "streifling.com/jason/cpolis/cmd/backend"
)

func CreateTag(c *b.Config) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		tmpl, err := template.ParseFiles(c.WebDir + "/templates/add-tag.html")
		template.Must(tmpl, err).ExecuteTemplate(w, "page-content", nil)
	}
}

func AddTag(c *b.Config, db *b.DB, s *b.CookieStore) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		db.AddTag(r.PostFormValue("tag"))

		session, err := s.Get(r, "cookie")
		if err != nil {
			tmpl, err := template.ParseFiles(c.WebDir + "/templates/login.html")
			msg := "Session nicht mehr gültig. Bitte erneut anmelden."
			template.Must(tmpl, err).ExecuteTemplate(w, "page-content", msg)
		}

		tmpl, err := template.ParseFiles(c.WebDir + "/templates/hub.html")
		tmpl = template.Must(tmpl, err)
		tmpl.ExecuteTemplate(w, "page-content", session.Values["role"])
	}
}
